##############################
# Author      : Erdogan Taskesen
# Version     : 1.0
# Department  : Delft University of Technology: Delft Bioinformatics Lab (DBL)
# E-mail      : e.taskesen@tudelft.nl
# Date        : October 2015
# www.gtexportal.org
# http://bioinformatics.tudelft.nl/dbl/software/
#################################


########################
# Set working directory
########################
# Download all files from the DBL website and set the the working directory
#setwd("C:/temp/gtexdata")
setwd("D:/Dropbox/TUdelft/ResearchSubjects/18_gTEX/manuscript Scientific Reports/sharefolder")
writedir = 'D:/Dropbox/TUdelft/ResearchSubjects/18_gTEX/manuscript Scientific Reports/sharefolder/'

print("Running tSNEbh on GTEx data!")

#################
# Set parameters
#################
max_iter=1000;
perplexity=30;
initial_dims=50;
dims=2;
theta=0.5;
showplot= TRUE;
prop_outliers = .1;
eps=NULL
eps_res=1000
showplot = as.logical(showplot);
eps=as.null.default(eps)


###############################
#Load required functions
###############################
source('SetParameters.R')
source('Function_dbscan.R')


##################################################
# Install packages, preferable from local source
##################################################
# source("http://bioconductor.org/biocLite.R")
install.packages("Rtsne_0.11.zip", repos = NULL, type = "source");
install.packages("fpc", dependencies = TRUE)
install.packages("ggplot2", dependencies = TRUE)
install.packages("scales", dependencies = TRUE)
install.packages("cluster", dependencies = TRUE)
install.packages("clusterSim", dependencies = TRUE)
library(fpc)
library(ggplot2)
library(scales)
library(cluster)
library(clusterSim)
library(Rtsne)


#############
# Import Data
#############
data=read.csv('GTExdata.csv',sep=",",header=F);

##############
# Run tSNE
##############
print("Running tSNE barns Hut on GTEx data")
rtsne_out <- Rtsne(as.matrix(data),dims,initial_dims,perplexity,theta,FALSE,TRUE,max_iter=max_iter)


##############
# Run DBSCAN
##############
print("Running DBSCAN!")
DBcl = dbscan_SH(rtsne_out$Y,eps,showplot,prop_outliers,eps_res)

##############
# Plot results
##############
plot(rtsne_out$Y,col=c("lightgrey",sample(rainbow(max(DBcl),v=.8)))[DBcl+1],pch=16)



